// MyInteropTest.h : Declaration of the CMyInteropTest

#pragma once
#include "resource.h"       // main symbols

#include "AtlTestProject_i.h"


#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif



// CMyInteropTest

class ATL_NO_VTABLE CMyInteropTest :
    public CComObjectRootEx<CComSingleThreadModel>,
    public CComCoClass<CMyInteropTest, &CLSID_MyInteropTest>,
    public IDispatchImpl<IMyInteropTest, &IID_IMyInteropTest, &LIBID_AtlTestProjectLib, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
    CMyInteropTest()
    {
    }

    DECLARE_REGISTRY_RESOURCEID(IDR_MYINTEROPTEST)


    BEGIN_COM_MAP(CMyInteropTest)
        COM_INTERFACE_ENTRY(IMyInteropTest)
        COM_INTERFACE_ENTRY(IDispatch)
    END_COM_MAP()



    DECLARE_PROTECT_FINAL_CONSTRUCT()

    HRESULT FinalConstruct()
    {
        return S_OK;
    }

    void FinalRelease()
    {
    }

public:
    STDMETHOD(TestDISPPARAM)(DISPPARAMS *pAttribute)
    { 
        pAttribute->rgvarg[0].vt = VT_I4;
        pAttribute->rgvarg[0].intVal = 10;

        return S_OK;
    }
};

OBJECT_ENTRY_AUTO(__uuidof(MyInteropTest), CMyInteropTest)
