﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Reflection;
using System.Threading;
using System.Diagnostics;

namespace ConsoleApplication1
{
    class Program
    {
        [STAThread]
        unsafe static void Main(string[] args)
        {
            Debug.WriteLine(Thread.CurrentThread.GetApartmentState());

            Guid[] guids = new Guid[3];

            object[] objectsArray = new object[3];
            objectsArray[0] = 5.6;
            objectsArray[1] = 5;
            objectsArray[2] = "TEST";

            fixed (void* pGuid0 = &guids[0])
            {
                IntPtr pGuid = new IntPtr(pGuid0);
                Marshal.GetNativeVariantForObject(5.6, pGuid);
            }

            fixed (void* pGuid1 = &guids[1])
            {
                IntPtr pGuid = new IntPtr(pGuid1);
                Marshal.GetNativeVariantForObject(5, pGuid);
            }

            fixed (void* pGuid2 = &guids[2])
            {
                IntPtr pGuid = new IntPtr(pGuid2);
                Marshal.GetNativeVariantForObject("test", pGuid);
            }

            stdole.DISPPARAMS dispParams = new stdole.DISPPARAMS();

            AtlTestProjectLib.MyInteropTestClass test = new AtlTestProjectLib.MyInteropTestClass();
            dispParams.cArgs = 3;
            dispParams.cNamedArgs = 3;

            int[] dispIDs = new int[] { 0, 1, 2};
            GCHandle idHandle = GCHandle.Alloc(dispIDs, GCHandleType.Pinned);
            IntPtr idPtr = idHandle.AddrOfPinnedObject();
            dispParams.rgdispidNamedArgs = idPtr;

            //dispParams.rgvarg = Marshal.UnsafeAddrOfPinnedArrayElement( objectsArray, 0);

            GCHandle gcHandle = GCHandle.Alloc(guids, GCHandleType.Pinned);
            IntPtr argPtr = gcHandle.AddrOfPinnedObject();

            dispParams.rgvarg = argPtr;

            test.TestDISPPARAM(ref dispParams);

            gcHandle.Free();
        }
    }



}
